diff --git a/test/unit/assets_test.rb b/test/unit/assets_test.rb
new file mode 100644
index 00000000..857e715f
--- /dev/null
+++ b/test/unit/assets_test.rb
@@ -0,0 +1,63 @@
+require "test_helper"
+require "hive/assets"
+
+class HiveAssetsTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_seed_and_scaffold_are_idempotent_and_preserve_edits
+    with_tmp_dir do |dir|
+      data = File.join(dir, "data")
+      project = File.join(dir, "project")
+      source = File.join(dir, "source")
+      FileUtils.mkdir_p(source)
+      File.write(File.join(source, "hello.txt"), "original\n")
+      FileUtils.mkdir_p(project)
+
+      Hive::Assets.seed_shared!(source: source, destination: data, version: "0.1.0")
+      result = Hive::Assets.scaffold_project!(project, source: source)
+      generated = File.join(project, ".hive", "hello.txt")
+      assert_equal [ ".hive/hello.txt" ], result[:created]
+      assert_equal "original\n", File.read(generated)
+
+      File.write(generated, "user edit\n")
+      second = Hive::Assets.scaffold_project!(project, source: source)
+      assert_equal [ ".hive/hello.txt" ], second[:conflicts]
+      assert_equal "user edit\n", File.read(generated)
+    end
+  end
+
+  def test_seed_repairs_the_current_pointer_for_an_existing_complete_release
+    with_tmp_dir do |dir|
+      source = File.join(dir, "source")
+      release = File.join(dir, "releases", "0.1.0")
+      FileUtils.mkdir_p([ source, release ])
+      File.write(File.join(source, "shared.txt"), "shared\n")
+      File.write(File.join(release, ".complete"), "0.1.0\n")
+      File.symlink("0.0.9", File.join(dir, "releases", "current"))
+
+      Hive::Assets.seed_shared!(source: source, destination: File.join(dir, "releases"), version: "0.1.0")
+
+      assert_equal "0.1.0", File.readlink(File.join(dir, "releases", "current"))
+    end
+  end
+
+  def test_scaffold_rejects_a_symlinked_hive_directory
+    with_tmp_dir do |dir|
+      project = File.join(dir, "project")
+      outside = File.join(dir, "outside")
+      source = File.join(dir, "source")
+      FileUtils.mkdir_p([ project, outside, source ])
+      File.write(File.join(source, "settings.yml"), "version: 1\n")
+      File.symlink(outside, File.join(project, ".hive"))
+
+      assert_raises(Hive::ConfigError) do
+        Hive::Assets.scaffold_project!(project, source: source)
+      end
+      refute File.exist?(File.join(outside, "settings.yml"))
+    end
+  end
+
+  def test_rejects_broad_project_root
+    assert_raises(Hive::ConfigError) { Hive::Assets.scaffold_project!("/") }
+  end
+end
diff --git a/test/unit/command_name_test.rb b/test/unit/command_name_test.rb
new file mode 100644
index 00000000..4f310248
--- /dev/null
+++ b/test/unit/command_name_test.rb
@@ -0,0 +1,30 @@
+require "test_helper"
+require "hive/command_name"
+
+class HiveCommandNameTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_selects_hive_when_unclaimed
+    with_tmp_dir do |dir|
+      assert_equal "hive", Hive::CommandName.select(path: dir)
+    end
+  end
+
+  def test_selects_hv_when_foreign_hive_is_on_path
+    with_tmp_dir do |dir|
+      File.write(File.join(dir, "hive"), "#!/bin/sh\n")
+      File.chmod(0o755, File.join(dir, "hive"))
+      assert_equal "hv", Hive::CommandName.select(path: dir, installed_executable: "/elsewhere/hv")
+    end
+  end
+
+  def test_stable_executable_prefers_the_path_resolved_command
+    with_tmp_dir do |dir|
+      stable = File.join(dir, "hv")
+      File.write(stable, "#!/bin/sh\n")
+      File.chmod(0o755, stable)
+
+      assert_equal stable, Hive::CommandName.stable_executable(path: dir, current: "/cellar/hive/0.1.0/bin/hv")
+    end
+  end
+end
diff --git a/test/unit/commands/init/prompts_test.rb b/test/unit/commands/init/prompts_test.rb
index 734b955d..bdfdbadc 100644
--- a/test/unit/commands/init/prompts_test.rb
+++ b/test/unit/commands/init/prompts_test.rb
@@ -34,7 +34,7 @@ class InitPromptsTest < Minitest::Test
 
   # Build the canonical "all defaults" answer key set so tests can assert
   # against the same shape Init#call will pass to the ERB template.
-  def all_defaults
+  def all_defaults(daemon_enabled: false)
     {
       "planning_agent" => "claude",
       "development_agent" => "codex",
@@ -46,7 +46,10 @@ class InitPromptsTest < Minitest::Test
       "timeouts" => Hive::Commands::Init::Prompts::LIMIT_KEYS.each_with_object({}) do |k, h|
         h[k] = Hive::Config::DEFAULTS["timeout_sec"][k]
       end,
-      "daemon_enabled" => true
+      "daemon_enabled" => daemon_enabled,
+      "provider" => "openai",
+      "model" => "gpt-5",
+      "credential_env" => "OPENAI_API_KEY"
     }
   end
 
@@ -59,11 +62,16 @@ class InitPromptsTest < Minitest::Test
   #         open_pr, finalize, review_ci, review_triage, review_fix,
   #         review_browser)
   #  14. daemon enable Y/n            (added under ADR-024)
-  #  15. confirmation Y/n
+  #  15. provider
+  #  16. model
+  #  17. credential environment variable
+  #  18. confirmation Y/n
   # Each line is one answer; blank line = accept default.
   def interactive_input(planning: "", development: "", reviewers: "",
-                        triage_bias: "", limits: ([ "" ] * 9), daemon: "", confirm: "")
-    [ planning, development, reviewers, triage_bias, *limits, daemon, confirm ].map { |a| "#{a}\n" }.join
+                        triage_bias: "", limits: ([ "" ] * 9), daemon: "",
+                        provider: "", model: "", credential_env: "", confirm: "")
+    [ planning, development, reviewers, triage_bias, *limits, daemon,
+      provider, model, credential_env, confirm ].map { |a| "#{a}\n" }.join
   end
 
   # --- non-TTY: short-circuit to defaults ----------------------------------
@@ -111,7 +119,7 @@ class InitPromptsTest < Minitest::Test
   def test_interactive_all_defaults
     prompts, _output = make_prompts(interactive_input)
     answers = prompts.collect
-    assert_equal all_defaults, answers
+    assert_equal all_defaults(daemon_enabled: true), answers
   end
 
   def test_interactive_all_defaults_summary_says_so
@@ -138,10 +146,10 @@ class InitPromptsTest < Minitest::Test
 
   def test_interactive_planning_agent_unknown_reprompts_then_accepts
     # First answer is invalid → re-prompt; second answer is valid.
-    # 16 reads total: planning (invalid + retry) + dev + reviewers
-    # + triage bias + 9 limits + daemon + confirm. Each blank line
+    # 19 reads total: planning (invalid + retry) + dev + reviewers
+    # + triage bias + 9 limits + daemon + provider/model/credential + confirm. Each blank line
     # accepts the default.
-    raw = ([ "nonexistent", "claude" ] + ([ "" ] * 14)).join("\n") + "\n"
+    raw = ([ "nonexistent", "claude" ] + ([ "" ] * 17)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(raw)
     answers = prompts.collect
     assert_equal "claude", answers["planning_agent"]
@@ -149,7 +157,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_interactive_planning_agent_index_out_of_range_reprompts
-    raw = ([ "7", "claude" ] + ([ "" ] * 14)).join("\n") + "\n"
+    raw = ([ "7", "claude" ] + ([ "" ] * 17)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(raw)
     answers = prompts.collect
     assert_equal "claude", answers["planning_agent"]
@@ -189,7 +197,7 @@ class InitPromptsTest < Minitest::Test
     # Build the input manually since interactive_input doesn't allow
     # multi-line reviewer answers cleanly. Trailing values are triage
     # bias, nine limits, daemon, and confirm.
-    input = ([ "", "", "7", "1,2" ] + ([ "" ] * 12)).join("\n") + "\n"
+    input = ([ "", "", "7", "1,2" ] + ([ "" ] * 15)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[claude-ce-code-review codex-ce-code-review], answers["enabled_reviewers"]
@@ -197,7 +205,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_interactive_reviewers_unknown_name_reprompts
-    input = ([ "", "", "nope", "1" ] + ([ "" ] * 12)).join("\n") + "\n"
+    input = ([ "", "", "nope", "1" ] + ([ "" ] * 15)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[claude-ce-code-review], answers["enabled_reviewers"]
@@ -231,7 +239,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_interactive_triage_bias_unknown_reprompts
-    input = ([ "", "", "", "bad", "2" ] + ([ "" ] * 11)).join("\n") + "\n"
+    input = ([ "", "", "", "bad", "2" ] + ([ "" ] * 14)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal "safetyist", answers["triage_bias"]
@@ -277,8 +285,8 @@ class InitPromptsTest < Minitest::Test
 
   def test_interactive_limits_zero_budget_reprompts
     # First answer 0,300 fails validation → re-prompt; second answer 10,600 accepted.
-    # Trailing pair is daemon + confirm (both blank → daemon enabled, confirm yes).
-    input = ([ "", "", "", "", "0,300", "10,600" ] + ([ "" ] * 10)).join("\n") + "\n"
+    # Trailing values cover the remaining limits, daemon, provider settings, and confirmation.
+    input = ([ "", "", "", "", "0,300", "10,600" ] + ([ "" ] * 13)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal 10, answers["budgets"]["brainstorm"]
@@ -288,7 +296,7 @@ class InitPromptsTest < Minitest::Test
 
   def test_interactive_limits_malformed_format_reprompts
     # "30" without comma fails the <budget>,<timeout> shape → re-prompt
-    input = ([ "", "", "", "", "30", "30,900" ] + ([ "" ] * 10)).join("\n") + "\n"
+    input = ([ "", "", "", "", "30", "30,900" ] + ([ "" ] * 13)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal 30, answers["budgets"]["brainstorm"]
@@ -347,7 +355,7 @@ class InitPromptsTest < Minitest::Test
     # daemon slot. interactive_input(daemon: "maybe") provides "maybe" + "" (confirm).
     # We need: maybe (rejected) → y (accepted as daemon=enabled) → blank (confirm).
     # So push two extra reads in.
-    input = interactive_input(daemon: "maybe", confirm: "") + "y\n\n"
+    input = ([ "" ] * 13 + [ "maybe", "y", "", "", "", "" ]).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal true, answers["daemon_enabled"]
@@ -361,17 +369,16 @@ class InitPromptsTest < Minitest::Test
     assert_match(/daemon\s+= disabled/, summary)
   end
 
-  def test_non_tty_default_includes_daemon_enabled_true
+  def test_non_tty_default_keeps_daemon_disabled_without_consent
     prompts, _output, _summary = make_prompts("", tty: false)
     answers = prompts.collect
-    assert_equal true, answers["daemon_enabled"],
-                 "non-TTY callers should land on the same recommended default as TTY (Y)"
+    assert_equal false, answers["daemon_enabled"]
   end
 
   def test_non_tty_summary_includes_daemon_state
     prompts, _output, summary_io = make_prompts("", tty: false)
     prompts.collect
-    assert_match(/daemon=enabled/, summary_io.string)
+    assert_match(/daemon=disabled/, summary_io.string)
   end
 
   def test_non_tty_default_includes_triage_bias_courageous
@@ -465,7 +472,7 @@ class InitPromptsTest < Minitest::Test
     # Truncate the input transcript right before confirmation. read_line
     # must distinguish nil-from-gets (EOF) from an empty line and bubble
     # Aborted up the stack rather than silently confirming.
-    inputs = ([ "" ] * 14).join("\n") + "\n"  # 14 blank reads, then EOF
+    inputs = ([ "" ] * 17).join("\n") + "\n"  # 17 blank reads, then EOF
     prompts, _output, _summary = make_prompts(inputs)
     assert_raises(Hive::Commands::Init::Prompts::Aborted) { prompts.collect }
   end
@@ -493,8 +500,8 @@ class InitPromptsTest < Minitest::Test
   # that would produce an invalid YAML key (parses to nil) which
   # validate_reviewers! rejects on the next `hive run`. Re-prompt instead.
   def test_reviewers_comma_only_reprompts
-    # Trailing values are triage bias, nine limits, daemon, and confirm.
-    input = ([ "", "", ",", "1" ] + ([ "" ] * 12)).join("\n") + "\n"
+    # Trailing values are triage bias, nine limits, daemon, provider settings, and confirmation.
+    input = ([ "", "", ",", "1" ] + ([ "" ] * 15)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[claude-ce-code-review], answers["enabled_reviewers"]
@@ -502,7 +509,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_reviewers_whitespace_only_reprompts
-    input = ([ "", "", "  ,  ,  ", "2" ] + ([ "" ] * 12)).join("\n") + "\n"
+    input = ([ "", "", "  ,  ,  ", "2" ] + ([ "" ] * 15)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[codex-ce-code-review], answers["enabled_reviewers"]
diff --git a/test/unit/dependency_check_test.rb b/test/unit/dependency_check_test.rb
new file mode 100644
index 00000000..0ec0753b
--- /dev/null
+++ b/test/unit/dependency_check_test.rb
@@ -0,0 +1,11 @@
+require "test_helper"
+require "hive/dependency_check"
+
+class HiveDependencyCheckTest < Minitest::Test
+  def test_reports_missing_tools_without_installing
+    rows = Hive::DependencyCheck.call(path: "")
+    assert_equal %w[git bash claude gh jq], rows.map { |row| row[:name] }
+    assert rows.all? { |row| row[:status] == :missing }
+    assert rows.all? { |row| row[:hint].include?("Install") }
+  end
+end
diff --git a/test/unit/first_run_config_test.rb b/test/unit/first_run_config_test.rb
new file mode 100644
index 00000000..83d932f2
--- /dev/null
+++ b/test/unit/first_run_config_test.rb
@@ -0,0 +1,53 @@
+require "test_helper"
+require "hive/config"
+
+class FirstRunConfigTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_writes_choices_and_credential_reference_but_not_secret
+    with_tmp_dir do |dir|
+      path = File.join(dir, "config.yml")
+      Hive::Config.write_provider_config!(
+        path: path,
+        provider: "openai",
+        model: "gpt-5",
+        credential_env: "OPENAI_API_KEY"
+      )
+      data = YAML.safe_load_file(path)
+      assert_equal "openai", data["provider"]
+      assert_equal "env:OPENAI_API_KEY", data["credential_source"]
+      assert_equal 0o600, File.stat(path).mode & 0o777
+    end
+  end
+
+  def test_rejects_raw_secret_values
+    with_tmp_dir do |dir|
+      assert_raises(Hive::ConfigError) do
+        Hive::Config.write_provider_config!(
+          path: File.join(dir, "config.yml"),
+          provider: "openai",
+          model: "gpt-5",
+          credential_env: "sk-secret-value"
+        )
+      end
+    end
+  end
+
+  def test_preserves_unrelated_existing_xdg_configuration
+    with_tmp_dir do |dir|
+      path = File.join(dir, "config.yml")
+      File.write(path, { "theme" => "dark", "provider" => "legacy" }.to_yaml)
+
+      Hive::Config.write_provider_config!(
+        path: path,
+        provider: "openai",
+        model: "gpt-5",
+        credential_env: "OPENAI_API_KEY"
+      )
+
+      data = YAML.safe_load_file(path)
+      assert_equal "dark", data["theme"]
+      assert_equal "openai", data["provider"]
+    end
+  end
+end
diff --git a/test/unit/install_channel_test.rb b/test/unit/install_channel_test.rb
new file mode 100644
index 00000000..d3cf0c71
--- /dev/null
+++ b/test/unit/install_channel_test.rb
@@ -0,0 +1,105 @@
+require "test_helper"
+require "hive/install/channel"
+
+class InstallChannelTest < Minitest::Test
+  class FakeRunner
+    attr_reader :commands
+
+    def initialize(outputs: {})
+      @commands = []
+      @outputs = outputs
+    end
+
+    def call(*command)
+      @commands << command
+      [ @outputs.fetch(command, ""), "", Struct.new(:success?).new(true) ]
+    end
+  end
+
+  def test_homebrew_update_delegates_without_writing_executable
+    runner = FakeRunner.new
+    receipt = {
+      "schema_version" => 1,
+      "channel" => "homebrew",
+      "package" => "hive/tap/hive",
+      "command_name" => "hive",
+      "executable" => "/opt/homebrew/opt/hive/bin/hv",
+      "release_source" => "https://example.test/release",
+      "managed_files" => [ "/opt/homebrew/opt/hive/bin/hv" ]
+    }
+    Hive::Install::Channel.new(receipt, runner: runner).update
+    assert_equal [ "brew", "upgrade", "hive/tap/hive" ], runner.commands.last
+  end
+
+  def test_homebrew_ownership_requires_the_receipt_executable_to_match_the_formula_prefix
+    Dir.mktmpdir("hive-brew-prefix") do |prefix|
+      executable = File.join(prefix, "bin", "hv")
+      FileUtils.mkdir_p(File.dirname(executable))
+      File.write(executable, "#!/bin/sh\n")
+      runner = FakeRunner.new(outputs: {
+        [ "brew", "--prefix", "hive" ] => "#{prefix}\n"
+      })
+      receipt = {
+        "schema_version" => 1,
+        "channel" => "homebrew",
+        "package" => "hive",
+        "command_name" => "hv",
+        "executable" => executable,
+        "release_source" => "https://example.test/release",
+        "managed_files" => [ executable ]
+      }
+
+      assert Hive::Install::Channel.new(receipt, runner: runner).verify_ownership!
+    end
+  end
+
+  def test_aur_selects_available_helper
+    runner = FakeRunner.new
+    receipt = {
+      "schema_version" => 1,
+      "channel" => "aur",
+      "package" => "hive-bin",
+      "command_name" => "hive",
+      "executable" => "/usr/bin/hv",
+      "release_source" => "https://example.test/release",
+      "managed_files" => [ "/usr/bin/hv" ]
+    }
+    channel = Hive::Install::Channel.new(receipt, runner: runner, resolver: ->(name) { name == "paru" ? "/bin/paru" : nil })
+    channel.update
+    assert_equal [ "/bin/paru", "-S", "--needed", "hive-bin" ], runner.commands.last
+  end
+
+  def test_aur_uninstall_uses_the_available_helper
+    runner = FakeRunner.new
+    receipt = {
+      "schema_version" => 1,
+      "channel" => "aur",
+      "package" => "hive-bin",
+      "command_name" => "hv",
+      "executable" => "/usr/bin/hv",
+      "release_source" => "https://example.test/release",
+      "managed_files" => [ "/usr/bin/hv" ]
+    }
+    channel = Hive::Install::Channel.new(receipt, runner: runner, resolver: ->(name) { name == "yay" ? "/bin/yay" : nil })
+
+    channel.uninstall
+
+    assert_equal [ "/bin/yay", "-Rns", "--noconfirm", "hive-bin" ], runner.commands.last
+  end
+
+  def test_aur_ownership_must_match_the_receipt_package
+    command = [ "pacman", "-Qqo", "/usr/bin/hv" ]
+    runner = FakeRunner.new(outputs: { command => "other-package\n" })
+    receipt = {
+      "schema_version" => 1,
+      "channel" => "aur",
+      "package" => "hive-bin",
+      "command_name" => "hv",
+      "executable" => "/usr/bin/hv",
+      "release_source" => "https://example.test/release",
+      "managed_files" => [ "/usr/bin/hv" ]
+    }
+
+    assert_raises(Hive::ConfigError) { Hive::Install::Channel.new(receipt, runner: runner).verify_ownership! }
+  end
+end
diff --git a/test/unit/install_receipt_test.rb b/test/unit/install_receipt_test.rb
new file mode 100644
index 00000000..9a84ba0e
--- /dev/null
+++ b/test/unit/install_receipt_test.rb
@@ -0,0 +1,55 @@
+require "test_helper"
+require "hive/install/receipt"
+
+class InstallReceiptTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_round_trip_and_validation
+    with_tmp_dir do |dir|
+      path = File.join(dir, "receipt.yml")
+      receipt = Hive::Install::Receipt.write!(
+        path: path,
+        data: {
+          "channel" => "shell",
+          "package" => "hive",
+          "command_name" => "hv",
+          "executable" => File.join(dir, "hv"),
+          "executable_sha256" => "a" * 64,
+          "release_source" => "https://example.test/v0.1.0",
+          "installer" => File.join(dir, "install.sh"),
+          "installer_sha256" => "b" * 64,
+          "uninstaller" => File.join(dir, "uninstall-shell.sh"),
+          "uninstaller_sha256" => "c" * 64,
+          "managed_files" => [
+            File.join(dir, "hv"),
+            File.join(dir, "install.sh"),
+            File.join(dir, "uninstall-shell.sh")
+          ]
+        }
+      )
+      assert_equal "shell", receipt["channel"]
+      assert_equal 1, Hive::Install::Receipt.load(path)["schema_version"]
+    end
+  end
+
+  def test_rejects_unknown_channel
+    error = assert_raises(Hive::ConfigError) do
+      Hive::Install::Receipt.validate!("channel" => "guess")
+    end
+    assert_includes error.message, "channel"
+  end
+
+  def test_rejects_missing_schema_and_shell_helper_fields
+    base = {
+      "channel" => "shell",
+      "package" => "hive",
+      "command_name" => "hv",
+      "executable" => "/tmp/hv",
+      "release_source" => "https://example.test/v0.1.0"
+    }
+    assert_raises(Hive::ConfigError) { Hive::Install::Receipt.validate!(base) }
+    assert_raises(Hive::ConfigError) do
+      Hive::Install::Receipt.validate!(base.merge("schema_version" => 1))
+    end
+  end
+end
diff --git a/test/unit/paths_test.rb b/test/unit/paths_test.rb
new file mode 100644
index 00000000..c7fef95c
--- /dev/null
+++ b/test/unit/paths_test.rb
@@ -0,0 +1,55 @@
+require "test_helper"
+require "hive/paths"
+
+class HivePathsTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_standard_xdg_defaults
+    with_env(
+      "HOME" => "/tmp/hive-home",
+      "XDG_CONFIG_HOME" => nil,
+      "XDG_DATA_HOME" => nil,
+      "XDG_STATE_HOME" => nil,
+      "XDG_CACHE_HOME" => nil,
+      "XDG_RUNTIME_DIR" => nil
+    ) do
+      assert_equal "/tmp/hive-home/.config/hive", Hive::Paths.config_dir
+      assert_equal "/tmp/hive-home/.local/share/hive", Hive::Paths.data_dir
+      assert_equal "/tmp/hive-home/.local/state/hive", Hive::Paths.state_dir
+      assert_equal "/tmp/hive-home/.cache/hive", Hive::Paths.cache_dir
+      assert_equal "/tmp/hive-home/.local/state/hive/run", Hive::Paths.runtime_dir
+    end
+  end
+
+  def test_xdg_overrides
+    with_env(
+      "XDG_CONFIG_HOME" => "/c",
+      "XDG_DATA_HOME" => "/d",
+      "XDG_STATE_HOME" => "/s",
+      "XDG_CACHE_HOME" => "/k",
+      "XDG_RUNTIME_DIR" => "/r"
+    ) do
+      assert_equal "/c/hive", Hive::Paths.config_dir
+      assert_equal "/d/hive", Hive::Paths.data_dir
+      assert_equal "/s/hive", Hive::Paths.state_dir
+      assert_equal "/k/hive", Hive::Paths.cache_dir
+      assert_equal "/r/hive", Hive::Paths.runtime_dir
+    end
+  end
+
+  def test_service_state_override_is_consumed
+    with_env("HIVE_STATE_DIR" => "/service/state", "XDG_STATE_HOME" => "/ignored") do
+      assert_equal "/service/state", Hive::Paths.state_dir
+    end
+  end
+
+  private
+
+  def with_env(values)
+    old = values.to_h { |key, _| [ key, ENV[key] ] }
+    values.each { |key, value| value ? ENV[key] = value : ENV.delete(key) }
+    yield
+  ensure
+    old.each { |key, value| value ? ENV[key] = value : ENV.delete(key) }
+  end
+end
diff --git a/test/unit/service_test.rb b/test/unit/service_test.rb
new file mode 100644
index 00000000..2a39742f
--- /dev/null
+++ b/test/unit/service_test.rb
@@ -0,0 +1,99 @@
+require "test_helper"
+require "hive/service"
+
+class HiveServiceTest < Minitest::Test
+  include HiveTestHelper
+
+  class FakeRunner
+    attr_reader :commands
+
+    def initialize(success: true)
+      @success = success
+      @commands = []
+    end
+
+    def call(*command)
+      @commands << command
+      [ "", "", Struct.new(:success?).new(@success) ]
+    end
+  end
+
+  class SequenceRunner
+    def initialize(*results)
+      @results = results
+    end
+
+    def call(*)
+      success = @results.shift
+      [ "", "reload failed", Struct.new(:success?).new(success) ]
+    end
+  end
+
+  def test_systemd_registers_stopped_then_starts_on_request
+    with_tmp_dir do |dir|
+      runner = FakeRunner.new
+      service = Hive::Services::SystemdUser.new(
+        executable: "/opt/hive/bin/hv",
+        config_home: dir,
+        runner: runner
+      )
+      service.register
+      assert File.file?(File.join(dir, "systemd/user/hive.service"))
+      assert_equal [ [ "systemctl", "--user", "daemon-reload" ] ], runner.commands
+
+      service.start
+      assert_equal [ "systemctl", "--user", "enable", "--now", "hive.service" ], runner.commands.last
+    end
+  end
+
+  def test_launchd_registration_is_idempotent_and_updates_executable
+    with_tmp_dir do |dir|
+      runner = FakeRunner.new
+      service = Hive::Services::Launchd.new(
+        executable: "/one/hive",
+        home: dir,
+        runner: runner
+      )
+      service.register
+      path = File.join(dir, "Library/LaunchAgents/org.hive.daemon.plist")
+      assert_includes File.read(path), "/one/hive"
+
+      Hive::Services::Launchd.new(executable: "/two/hv", home: dir, runner: runner).register
+      assert_includes File.read(path), "/two/hv"
+      refute_includes File.read(path), "/one/hive"
+    end
+  end
+
+  def test_systemd_registration_failure_removes_new_definition
+    with_tmp_dir do |dir|
+      service = Hive::Services::SystemdUser.new(
+        executable: "/opt/hive/bin/hv",
+        config_home: dir,
+        runner: SequenceRunner.new(false, true)
+      )
+
+      assert_raises(Hive::Error) { service.register }
+      refute File.exist?(File.join(dir, "systemd/user/hive.service"))
+    end
+  end
+
+  def test_unregister_without_a_definition_is_a_manager_independent_no_op
+    with_tmp_dir do |dir|
+      systemd_runner = FakeRunner.new(success: false)
+      launchd_runner = FakeRunner.new(success: false)
+
+      assert_equal :unregistered, Hive::Services::SystemdUser.new(
+        executable: "/opt/hive/bin/hv",
+        config_home: dir,
+        runner: systemd_runner
+      ).unregister
+      assert_equal :unregistered, Hive::Services::Launchd.new(
+        executable: "/opt/hive/bin/hv",
+        home: dir,
+        runner: launchd_runner
+      ).unregister
+      assert_empty systemd_runner.commands
+      assert_empty launchd_runner.commands
+    end
+  end
+end
diff --git a/test/unit/uninstall_test.rb b/test/unit/uninstall_test.rb
new file mode 100644
index 00000000..a7db29bc
--- /dev/null
+++ b/test/unit/uninstall_test.rb
@@ -0,0 +1,100 @@
+require "test_helper"
+require "digest"
+require "stringio"
+require "hive/commands/uninstall"
+
+class UninstallTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_cleanup_removes_only_unmodified_owned_files
+    with_tmp_dir do |dir|
+      hive_dir = File.join(dir, ".hive")
+      FileUtils.mkdir_p(hive_dir)
+      generated = File.join(hive_dir, "generated.yml")
+      modified = File.join(hive_dir, "modified.yml")
+      unknown = File.join(hive_dir, "unknown.yml")
+      File.write(generated, "generated\n")
+      File.write(modified, "changed\n")
+      File.write(unknown, "unknown\n")
+      manifest = {
+        "version" => 1,
+        "files" => {
+          ".hive/generated.yml" => Digest::SHA256.file(generated).hexdigest,
+          ".hive/modified.yml" => Digest::SHA256.hexdigest("original\n"),
+          "../escape" => Digest::SHA256.hexdigest("x")
+        }
+      }
+      File.write(File.join(hive_dir, "ownership.yml"), manifest.to_yaml)
+
+      result = Hive::Commands::Uninstall.cleanup_project(dir)
+      refute File.exist?(generated)
+      assert File.exist?(modified)
+      assert File.exist?(unknown)
+      assert_includes result[:preserved], ".hive/modified.yml"
+      assert_includes result[:preserved], "../escape"
+    end
+  end
+
+  def test_preview_and_service_unregister_precede_package_and_project_mutation
+    events = []
+    output = StringIO.new
+    output.define_singleton_method(:puts) do |line|
+      events << :preview
+      super(line)
+    end
+    channel = Object.new
+    channel.define_singleton_method(:verify_ownership!) { events << :verify }
+    channel.define_singleton_method(:uninstall) { events << :package }
+    service = Object.new
+    service.define_singleton_method(:unregister) { events << :service }
+    receipt = { "channel" => "shell", "package" => "hive" }
+
+    Hive::Commands::Uninstall.new(
+      output: output,
+      receipt_loader: ->(_path) { receipt },
+      channel_factory: ->(_loaded) { channel },
+      service: service
+    ).call
+
+    assert_operator events.index(:preview), :<, events.index(:service)
+    assert_operator events.index(:service), :<, events.index(:package)
+  end
+
+  def test_unregister_failure_stops_package_and_project_removal
+    events = []
+    channel = Object.new
+    channel.define_singleton_method(:verify_ownership!) { events << :verify }
+    channel.define_singleton_method(:uninstall) { events << :package }
+    service = Object.new
+    service.define_singleton_method(:unregister) do
+      events << :service
+      raise Hive::Error, "reload failed"
+    end
+    receipt = { "channel" => "shell", "package" => "hive" }
+
+    with_tmp_dir do |dir|
+      hive_dir = File.join(dir, ".hive")
+      FileUtils.mkdir_p(hive_dir)
+      generated = File.join(hive_dir, "generated.yml")
+      File.write(generated, "generated\n")
+      File.write(File.join(hive_dir, "ownership.yml"), {
+        "version" => 1,
+        "files" => { ".hive/generated.yml" => Digest::SHA256.file(generated).hexdigest }
+      }.to_yaml)
+
+      assert_raises(Hive::Error) do
+        Hive::Commands::Uninstall.new(
+          project_root: dir,
+          cleanup: true,
+          output: StringIO.new,
+          receipt_loader: ->(_path) { receipt },
+          channel_factory: ->(_loaded) { channel },
+          service: service
+        ).call
+      end
+
+      assert_equal %i[verify service], events
+      assert File.exist?(generated)
+    end
+  end
+end
